package brs.visitor.test;

import brs.*;
import brs.visitor.*;
import junit.framework.TestCase;

/**
 */
public class TestBSTFindNext extends TestCase {
    
    /**
     * Tests match with the examples shown in exam question 3.c.
     *
     */
    public void testNonEmptyCase() {
        BiTree t = new BiTree();
        IVisitor insert = new BSTInserter();
        IVisitor findnext = new BSTFindNext();
        
        t.execute(insert, 57);
        t.execute(insert, 33);
        t.execute(insert, 78);
        t.execute(insert, 63);
        t.execute(insert, 91);
        t.execute(insert, 59);
        t.execute(insert, 71);
        t.execute(insert, 70);
        
        BiTree t1 = t.getRightSubTree();  // root = 78;
        BiTree t2 = t1.getLeftSubTree();  // root = 63;
        BiTree t3 = t1.getRightSubTree(); // root = 91;
        BiTree t4 = t2.getRightSubTree().getLeftSubTree(); // root = 70;
        BiTree t5 = t3.getRightSubTree(); // empty tree.
        
        System.out.println("Given the tree:\n" + t + '\n');
        BiTree nlg = (BiTree)t.execute(findnext, 63);
        System.out.println("\nFindNext 63:\n" + nlg);
        assertEquals("FindNext 63: ", t4.toString(), nlg.toString());
        
        nlg = (BiTree)t.execute(findnext, 71);
        System.out.println("\nFindNext 71:\n" + nlg);
        assertEquals("FindNext 71: ", t1.toString(), nlg.toString());
        
        nlg = (BiTree)t.execute(findnext, 60);
        System.out.println("\nFindNext 60:\n" + nlg);
        assertEquals("FindNext 63: ", t2.toString(), nlg.toString());
        
        nlg = (BiTree)t.execute(findnext, 91);
        System.out.println("\nFindNext 91:\n" + nlg);
        assertEquals("FindNext 91: ", t5.toString(), nlg.toString());
    }
    
}
